;macro's for general use:
;=1 Dosseg ordering			.dosseg
;1b default startup			startup
;=2 Com mem resize			.com_startup(stacksize)
;=3 Exe_modify_mem stacksize		.exe_startup(stacksize)
;=4 Near stack(exe)startup code	.nearstack_startup
;=5 DOS Exit code				exit
;=6 TSR segment ordering		.resseg
;=8 INVOKE a proc with vars
;   8a PRINTS	procedure,message 
;   8b WRITES	message, handle, lengte
;   8c PRNMESS_VALUE	message(+4bytes+0), value	
;=9 Multiple push, pop( up to 4 arguments) 	pushs,pops

;CONSTANTS
lf			equ	10
cr			equ	13
tab			equ	9
bel			equ	7
single_quote		equ	22h
double_quote		equ	27h


.dosseg	macro

Dgroup group Data_seg, Const_seg, Stack_seg
 
Code_seg segment word public 'code'
assume CS:Code_seg,DS:Dgroup,SS:Dgroup
Code_seg ends
Data_seg segment word public 'data'
Data_seg ends
Const_seg segment word public 'const'
Const_seg ends
Stack_seg segment para stack 'stack'
Stack_seg ends

endm 

startup macro	stacksize

dgroup group Data_seg, Const_seg, Stack_seg

Code_seg segment word public 'code'
assume CS:Code_seg,DS:dgroup,ES:dgroup,SS:dgroup
	mov	ax,	dgroup
	mov	ds,	ax
ifnb	<stacksize>
	exe_modify_mem stacksize	
	push	ds
	pop	es
else
	mov	es,	ax
endif
Code_seg ends

Data_seg segment word public 'data'
Data_seg ends
Const_seg segment word public 'const'
Const_seg ends
Stack_seg segment para stack 'stack'
ifnb	<stacksize>
	stackjes	db	stacksize dup(?)
else
	stackjes	db	256	dup(?)
endif
Stack_seg ends
	
endm


.resseg	macro

Res_seg segment word public 'resident'
Res_seg ends
Endres_seg segment word public 'endres'
Endres_seg ends
.dosseg

endm


exit		macro	errorcode
ifnb	<errorcode> 
	mov	al,	errorcode
endif
	mov	ah,	04ch
	int	21h
endm

.nearstack_startup	macro 
;points ds to DGROUP and makes NEAR STACK(SS=DS)
	mov	dx,	DGROUP
	mov	ds,	dx
	mov	bx,	ss
	mov	cl,	4
	shl	bx,	cl
	mov	ss,	dx
	add	sp,	bx
endm

.com_startup macro	stacksize

;allocates a near stack on top of the program, set SP to it
;deallocate needed memory( assuming only one (code)seg)

	jmp	go
stackje	dw	stacksize	dup(?)
top_stack:
extrn $$_com_end: word			;this is a specific freelink variable
go:
	mov	bx,	$$_com_end
	mov	sp,	ds:top_stack
	shr	bx,	1
	shr	bx,	1
	shr	bx,	1
	shr	bx,	1
	inc	bx
	mov	ah,	04ah
	int	21h
endm

exe_modify_mem	macro stacksize
;sets ds to dgroup and deallocates memory assuming 
;dosseg ordering of segments( stack on top)
	mov	ax,	es
	mov	bx,	ss
	sub	bx,	ax
	add	bx,	stacksize/16
	mov	ah,	04ah
	int	21h
endm


printstring	macro	message 
	lea	si,	message
	call	print_string
endm

print_messvalue macro message
ifndef valuestring
	data_seg	segment
		extrn valuestring: byte
	data_seg	ends
endif
	call	value16string
	printstring	message
	printstring valuestring 
endm
	
write_string macro	message, handle, lengte
	push	ax
	push	bx
	push	cx
	push	dx
	mov	cx,	lengte
	mov	bx,	handle
	lea	dx,	message
	call	write_file_device
	jc	error_handling
	pop	ax
	pop	bx
	pop	cx
	pop	dx
endm

print_valuestring	macro		valuestr, mode

ifnb	valuestr 
	lea	si,	valuestr
else
	lea	si,	valuestring		;;default 'valuestring heap'
endif
if	mode==16
	call	value16string
endif
endm

pushs	macro	arg1,arg2,arg3,arg4

irp argnr,<arg1,arg2,arg3,arg4>
	ifnb	<argnr>
		push argnr
	endif
	endm
endm


pops	macro	arg1,arg2,arg3,arg4
irp argnr,<arg1,arg2,arg3,arg4>
	ifnb	<argnr>
		pop argnr
	endif
	endm
endm

